# coding: utf-8

"""
    PowerBot - Webservice for algotrading

    # TERMS AND CONDITIONS The PowerBot system provides B2B services for trading at intraday power markets. By using the PowerBot service, each user agrees to the terms and conditions of this licence: 1. The user confirms that they are familiar with the exchanges trading system and all relevant rules, is professionally qualified and in possession of a trading license for the relevant exchange. 2. The user will comply with the exchanges market rules (e.g. [EPEX Spot Market Rules](https://www.epexspot.com/en/downloads#rules-fees-processes) or [Nord Pool Market Rules](https://www.nordpoolgroup.com/trading/Rules-and-regulations/)) and will not endanger the exchange system at any time with heavy load from trading algorithms or by other use. 3. The user is aware of limits imposed by the exchange. 4. The user is solely liable for actions resulting from the use of PowerBot.   # INTRODUCTION PowerBot is a web-based software service enabling algorithmic trading on intraday power exchanges such as EPEX, Nord Pool, HUPX, BSP Southpool, TGE, OPCOM or ETPA. The service is straightforward to integrate in an existing software environment and provides a variety of programming interfaces for development of individual trading algorithms and software tools. Besides enabling fully automated intraday trading, it can be used to create tools for human traders providing relevant information and trading opportunities or can be integrated in existing software tools. For further details see https://www.powerbot-trading.com  ## Knowledge Base In addition to this API guide, please find the documentation at https://docs.powerbot-trading.com - the password will be provided by the PowerBot team. If not, please reach out to us at support@powerbot-trading.com  ## Endpoints The PowerBot service is available at the following REST endpoints:  | Instance      | Base URL for REST Endpoints                                      | |---------------|------------------------------------------------------------------| | EPEX          | https://staging.powerbot-trading.com/playground/epex/v2/api      | | Nord Pool     | https://staging.powerbot-trading.com/playground/nordpool/v2/api  | | HUPX          | https://staging.powerbot-trading.com/playground/hupx/v2/api      | | BSP Southpool | https://staging.powerbot-trading.com/playground/southpool/v2/api | | TGE           | https://staging.powerbot-trading.com/playground/tge/v2/api       | | IBEX          | https://staging.powerbot-trading.com/playground/ibex/v2/api      | | CROPEX        | https://staging.powerbot-trading.com/playground/cropex/v2/api    | | OPCOM         | https://staging.powerbot-trading.com/playground/opcom/v2/api     | | ETPA          | https://staging.powerbot-trading.com/playground/etpa/v2/api      | | BRM           | https://staging.powerbot-trading.com/playground/brm/v2/api       |  Access to endpoints is secured via an API Key, which needs to be passed as an \"api_key\" header in each request.   Notes on API Keys:  * API keys are specific to Test, Staging or Production.  * API keys are generated by the system administrator and need to be requested.  ## How to generate API clients (libraries) This OpenAPI specification can be used to generate API clients (programming libraries) for a wide range of programming languages using tools like [OpenAPI Generator](https://openapi-generator.tech/). A detailed guide can be found in the [knowledge base](https://docs.powerbot-trading.com/articles/getting-started/generating-clients/).  ## PowerBot Python client For Python, a ready-made client is also available on PyPI and can be downloaded locally via:  ```shell   pip install powerbot-client ```  ## Errors The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be in JSON format as follows:  ``` {   \"message\": \"... an error message ...\" } ```  ## Paging The API uses offset and limit parameters for paged operations. An X-Total-Count header is added to responses to indicate the total number of items in a paged response.  ## Cross-Origin Resource Sharing This API features Cross-Origin Resource Sharing (CORS) implemented in compliance with  [W3C spec](https://www.w3.org/TR/cors/). This allows cross-domain communication from the browser. All responses have a wildcard same-origin which makes them completely public and accessible to everyone, including any code on any site.  ## API Rate Limiting The API limits the number of concurrent calls to 50 - when that limit is reached, the client will receive 503 http status codes (service unavailable) with the following text:  ``` {   \"message\": \"API rate limit exceeded\" } ``` Clients should ensure that they stay within the limit for concurrent API calls.    ## Additional code samples Additional information and code samples demonstrating the use of the API can be found at in our [knowledge base](https://docs.powerbot-trading.com/docs/programmatic-access/)  # noqa: E501

    The version of the OpenAPI document: 2.17.0
    Contact: office@powerbot-trading.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from powerbot_asyncio_client.configuration import Configuration


class AuctionExchangePortfolioMapping(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'powerbot_portfolio_id': 'str',
        'exchange_portfolio_name': 'str',
        'currency_mapping': 'list[DeliveryAreaCurrencyMapping]',
        'delivery_areas': 'list[str]'
    }

    attribute_map = {
        'powerbot_portfolio_id': 'powerbot_portfolio_id',
        'exchange_portfolio_name': 'exchange_portfolio_name',
        'currency_mapping': 'currency_mapping',
        'delivery_areas': 'delivery_areas'
    }

    def __init__(self, powerbot_portfolio_id=None, exchange_portfolio_name=None, currency_mapping=None, delivery_areas=None, local_vars_configuration=None):  # noqa: E501
        """AuctionExchangePortfolioMapping - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._powerbot_portfolio_id = None
        self._exchange_portfolio_name = None
        self._currency_mapping = None
        self._delivery_areas = None
        self.discriminator = None

        if powerbot_portfolio_id is not None:
            self.powerbot_portfolio_id = powerbot_portfolio_id
        if exchange_portfolio_name is not None:
            self.exchange_portfolio_name = exchange_portfolio_name
        if currency_mapping is not None:
            self.currency_mapping = currency_mapping
        if delivery_areas is not None:
            self.delivery_areas = delivery_areas

    @property
    def powerbot_portfolio_id(self):
        """Gets the powerbot_portfolio_id of this AuctionExchangePortfolioMapping.  # noqa: E501

        The ID of the PowerBot portfolio.  # noqa: E501

        :return: The powerbot_portfolio_id of this AuctionExchangePortfolioMapping.  # noqa: E501
        :rtype: str
        """
        return self._powerbot_portfolio_id

    @powerbot_portfolio_id.setter
    def powerbot_portfolio_id(self, powerbot_portfolio_id):
        """Sets the powerbot_portfolio_id of this AuctionExchangePortfolioMapping.

        The ID of the PowerBot portfolio.  # noqa: E501

        :param powerbot_portfolio_id: The powerbot_portfolio_id of this AuctionExchangePortfolioMapping.  # noqa: E501
        :type powerbot_portfolio_id: str
        """

        self._powerbot_portfolio_id = powerbot_portfolio_id

    @property
    def exchange_portfolio_name(self):
        """Gets the exchange_portfolio_name of this AuctionExchangePortfolioMapping.  # noqa: E501

        The ID of the exchange portfolio.  # noqa: E501

        :return: The exchange_portfolio_name of this AuctionExchangePortfolioMapping.  # noqa: E501
        :rtype: str
        """
        return self._exchange_portfolio_name

    @exchange_portfolio_name.setter
    def exchange_portfolio_name(self, exchange_portfolio_name):
        """Sets the exchange_portfolio_name of this AuctionExchangePortfolioMapping.

        The ID of the exchange portfolio.  # noqa: E501

        :param exchange_portfolio_name: The exchange_portfolio_name of this AuctionExchangePortfolioMapping.  # noqa: E501
        :type exchange_portfolio_name: str
        """

        self._exchange_portfolio_name = exchange_portfolio_name

    @property
    def currency_mapping(self):
        """Gets the currency_mapping of this AuctionExchangePortfolioMapping.  # noqa: E501


        :return: The currency_mapping of this AuctionExchangePortfolioMapping.  # noqa: E501
        :rtype: list[DeliveryAreaCurrencyMapping]
        """
        return self._currency_mapping

    @currency_mapping.setter
    def currency_mapping(self, currency_mapping):
        """Sets the currency_mapping of this AuctionExchangePortfolioMapping.


        :param currency_mapping: The currency_mapping of this AuctionExchangePortfolioMapping.  # noqa: E501
        :type currency_mapping: list[DeliveryAreaCurrencyMapping]
        """

        self._currency_mapping = currency_mapping

    @property
    def delivery_areas(self):
        """Gets the delivery_areas of this AuctionExchangePortfolioMapping.  # noqa: E501

        A subset of delivery areas the exchange portfolio has access to, to which the mapping should be applied.  # noqa: E501

        :return: The delivery_areas of this AuctionExchangePortfolioMapping.  # noqa: E501
        :rtype: list[str]
        """
        return self._delivery_areas

    @delivery_areas.setter
    def delivery_areas(self, delivery_areas):
        """Sets the delivery_areas of this AuctionExchangePortfolioMapping.

        A subset of delivery areas the exchange portfolio has access to, to which the mapping should be applied.  # noqa: E501

        :param delivery_areas: The delivery_areas of this AuctionExchangePortfolioMapping.  # noqa: E501
        :type delivery_areas: list[str]
        """

        self._delivery_areas = delivery_areas

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AuctionExchangePortfolioMapping):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AuctionExchangePortfolioMapping):
            return True

        return self.to_dict() != other.to_dict()
